/////////transmitter/////////////
#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
#include <string.h>
///////mpu6050///////
#include <Wire.h>
#include <MPU6050.h>

///////////mpu6050 variables//////////////////////
MPU6050 mpu;
unsigned long timer = 0;
float timeStep = 0.01;
float pitch = 0;
float roll = 0;
float yaw = 0;
//////////transmitter variables////////////
RF24 radio(7,8);
const byte rxAddr[6] = "00001";
typedef struct{
  float x_turn;
  float y_speed;
  float servo_1;
  float servo_2;
  float servo_3;
  float servo_4;
  }
A_t;
A_t duino;
////////////////////////////////

////////////////////////////////
int servobutton[4] = {3,4,5,6};
////////////////////////////////
void setup()
{
  //////buttons for servo/////////
  for(int i=0;i<4;i++)
    pinMode(servobutton[i],INPUT);
  ////////////transmitter///////////
  radio.begin();
  radio.setRetries(15, 15);
  radio.openWritingPipe(rxAddr);
  
  radio.stopListening();
  ///////////receiver////////////
 // Serial.begin(115200);
  while(!mpu.begin(MPU6050_SCALE_2000DPS, MPU6050_RANGE_2G))
  {
    Serial.println("Could not find a valid MPU6050 sensor, check wiring!");
    delay(500);
  }

  //mpu.calibrateGyro();
  mpu.setThreshold(3);
  /////////////////////////////////////
  }

void loop()
{ 
  //status for servo buttons//
  duino.servo_1 = digitalRead(servobutton[0]);
  duino.servo_2 = digitalRead(servobutton[1]);
  duino.servo_3 = digitalRead(servobutton[2]);
  duino.servo_4 = digitalRead(servobutton[3]);
  
  //calculating x and y directions//
  timer = millis();
  
  Vector norm = mpu.readNormalizeGyro();
  pitch = pitch + norm.YAxis * timeStep;
  roll = roll + norm.XAxis * timeStep;
  yaw = yaw + norm                                                              .ZAxis * timeStep;
  
  Serial.print(" Pitch = ");
  Serial.print(pitch);
  Serial.print(" Roll = ");
  Serial.print(roll);  
  Serial.print(" Yaw = ");
  Serial.println(yaw);
  duino.x_turn =  roll;
  duino.y_speed = pitch;
  // Wait to full timeStep period
  delay((timeStep*1000) - (millis() - timer));
 // delay(15);
  //////transmitting////////
  radio.write(&duino, sizeof(duino));
  //////////////////////////
  //delay(100);
}
